# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class LookupsPost(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        LookupsPost - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'mac_address': 'str',
            'ip_address': 'str',
            'node': 'str'
        }

        self.attribute_map = {
            'mac_address': 'macAddress',
            'ip_address': 'ipAddress',
            'node': 'node'
        }

        self._mac_address = None
        self._ip_address = None
        self._node = None

    @property
    def mac_address(self):
        """
        Gets the mac_address of this LookupsPost.
        MAC Address for the Lookup Record

        :return: The mac_address of this LookupsPost.
        :rtype: str
        """
        return self._mac_address

    @mac_address.setter
    def mac_address(self, mac_address):
        """
        Sets the mac_address of this LookupsPost.
        MAC Address for the Lookup Record

        :param mac_address: The mac_address of this LookupsPost.
        :type: str
        """
        self._mac_address = mac_address

    @property
    def ip_address(self):
        """
        Gets the ip_address of this LookupsPost.
        IP Address associated with the MAC Address

        :return: The ip_address of this LookupsPost.
        :rtype: str
        """
        return self._ip_address

    @ip_address.setter
    def ip_address(self, ip_address):
        """
        Sets the ip_address of this LookupsPost.
        IP Address associated with the MAC Address

        :param ip_address: The ip_address of this LookupsPost.
        :type: str
        """
        self._ip_address = ip_address

    @property
    def node(self):
        """
        Gets the node of this LookupsPost.
        Node associated with the Lookup Record

        :return: The node of this LookupsPost.
        :rtype: str
        """
        return self._node

    @node.setter
    def node(self, node):
        """
        Sets the node of this LookupsPost.
        Node associated with the Lookup Record

        :param node: The node of this LookupsPost.
        :type: str
        """
        self._node = node

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

